]> git.ipfire.org Git - thirdparty/git.git/blame - git-mergetool--lib.sh
config: improve error message for boolean config
[thirdparty/git.git] / git-mergetool--lib.sh
CommitLineData
11d62145 1# git-mergetool--lib is a shell library for common merge tool functions
f35ec546
DA
2
3: ${MERGE_TOOLS_DIR=$(git --exec-path)/mergetools}
073678b8 4
719518f5
DA
5IFS='
6'
7
17a1f1c5
DA
8mode_ok () {
9 if diff_mode
10 then
11 can_diff
12 elif merge_mode
13 then
14 can_merge
15 else
16 false
17 fi
18}
19
20is_available () {
21 merge_tool_path=$(translate_merge_tool_path "$1") &&
22 type "$merge_tool_path" >/dev/null 2>&1
23}
24
665682c9
JK
25list_config_tools () {
26 section=$1
27 line_prefix=${2:-}
28
29 git config --get-regexp $section'\..*\.cmd' |
30 while read -r key value
31 do
32 toolname=${key#$section.}
33 toolname=${toolname%.cmd}
34
35 printf "%s%s\n" "$line_prefix" "$toolname"
36 done
37}
38
17a1f1c5
DA
39show_tool_names () {
40 condition=${1:-true} per_line_prefix=${2:-} preamble=${3:-}
41 not_found_msg=${4:-}
665682c9 42 extra_content=${5:-}
17a1f1c5
DA
43
44 shown_any=
45 ( cd "$MERGE_TOOLS_DIR" && ls ) | {
83bbf9b9 46 while read scriptname
47 do
48 setup_tool "$scriptname" 2>/dev/null
80f5a167
PB
49 # We need an actual line feed here
50 variants="$variants
51$(list_tool_variants)"
83bbf9b9 52 done
80f5a167 53 variants="$(echo "$variants" | sort -u)"
83bbf9b9 54
55 for toolname in $variants
17a1f1c5
DA
56 do
57 if setup_tool "$toolname" 2>/dev/null &&
58 (eval "$condition" "$toolname")
59 then
60 if test -n "$preamble"
61 then
62 printf "%s\n" "$preamble"
63 preamble=
64 fi
65 shown_any=yes
66 printf "%s%s\n" "$per_line_prefix" "$toolname"
67 fi
68 done
69
665682c9
JK
70 if test -n "$extra_content"
71 then
72 if test -n "$preamble"
73 then
74 # Note: no '\n' here since we don't want a
75 # blank line if there is no initial content.
76 printf "%s" "$preamble"
77 preamble=
78 fi
79 shown_any=yes
80 printf "\n%s\n" "$extra_content"
81 fi
82
17a1f1c5
DA
83 if test -n "$preamble" && test -n "$not_found_msg"
84 then
85 printf "%s\n" "$not_found_msg"
86 fi
87
88 test -n "$shown_any"
89 }
90}
91
884630b2 92diff_mode () {
21d0ba7e
DA
93 test "$TOOL_MODE" = diff
94}
95
884630b2 96merge_mode () {
21d0ba7e
DA
97 test "$TOOL_MODE" = merge
98}
99
884630b2
DL
100gui_mode () {
101 test "$GIT_MERGETOOL_GUI" = true
102}
103
21d0ba7e 104translate_merge_tool_path () {
bc7a96a8 105 echo "$1"
21d0ba7e
DA
106}
107
108check_unchanged () {
240dc3e8
DA
109 if test "$MERGED" -nt "$BACKUP"
110 then
1b6a5343 111 return 0
21d0ba7e 112 else
240dc3e8
DA
113 while true
114 do
21d0ba7e 115 echo "$MERGED seems unchanged."
cce076e3 116 printf "Was the merge successful [y/n]? "
e622f41d 117 read answer || return 1
21d0ba7e 118 case "$answer" in
1b6a5343
DA
119 y*|Y*) return 0 ;;
120 n*|N*) return 1 ;;
21d0ba7e
DA
121 esac
122 done
123 fi
124}
125
126valid_tool () {
80ff2b68
DA
127 setup_tool "$1" && return 0
128 cmd=$(get_merge_tool_cmd "$1")
129 test -n "$cmd"
bc7a96a8
DA
130}
131
d2512fc9
JK
132setup_user_tool () {
133 merge_tool_cmd=$(get_merge_tool_cmd "$tool")
134 test -n "$merge_tool_cmd" || return 1
135
136 diff_cmd () {
137 ( eval $merge_tool_cmd )
d2512fc9
JK
138 }
139
140 merge_cmd () {
7c10605d 141 ( eval $merge_tool_cmd )
d2512fc9 142 }
12026f46
JS
143
144 list_tool_variants () {
145 echo "$tool"
146 }
d2512fc9
JK
147}
148
bc7a96a8 149setup_tool () {
073678b8
DA
150 tool="$1"
151
98e023de 152 # Fallback definitions, to be overridden by tools.
073678b8
DA
153 can_merge () {
154 return 0
155 }
156
157 can_diff () {
158 return 0
159 }
160
161 diff_cmd () {
1b6a5343 162 return 1
073678b8
DA
163 }
164
165 merge_cmd () {
1b6a5343 166 return 1
073678b8 167 }
bc7a96a8 168
073678b8
DA
169 translate_merge_tool_path () {
170 echo "$1"
171 }
172
83bbf9b9 173 list_tool_variants () {
174 echo "$tool"
175 }
176
7c10605d
DA
177 # Most tools' exit codes cannot be trusted, so By default we ignore
178 # their exit code and check the merged file's modification time in
179 # check_unchanged() to determine whether or not the merge was
180 # successful. The return value from run_merge_cmd, by default, is
181 # determined by check_unchanged().
182 #
183 # When a tool's exit code can be trusted then the return value from
184 # run_merge_cmd is simply the tool's exit code, and check_unchanged()
185 # is not called.
186 #
187 # The return value of exit_code_trustable() tells us whether or not we
188 # can trust the tool's exit code.
189 #
190 # User-defined and built-in tools default to false.
191 # Built-in tools advertise that their exit code is trustable by
192 # redefining exit_code_trustable() to true.
193
194 exit_code_trustable () {
195 false
196 }
197
83bbf9b9 198 if test -f "$MERGE_TOOLS_DIR/$tool"
bc7a96a8 199 then
83bbf9b9 200 . "$MERGE_TOOLS_DIR/$tool"
201 elif test -f "$MERGE_TOOLS_DIR/${tool%[0-9]}"
202 then
203 . "$MERGE_TOOLS_DIR/${tool%[0-9]}"
204 else
d2512fc9
JK
205 setup_user_tool
206 return $?
bc7a96a8
DA
207 fi
208
d2512fc9
JK
209 # Now let the user override the default command for the tool. If
210 # they have not done so then this will return 1 which we ignore.
211 setup_user_tool
bc7a96a8 212
83bbf9b9 213 if ! list_tool_variants | grep -q "^$tool$"
214 then
215 return 1
216 fi
217
bc7a96a8
DA
218 if merge_mode && ! can_merge
219 then
220 echo "error: '$tool' can not be used to resolve merges" >&2
62957bea 221 return 1
bc7a96a8
DA
222 elif diff_mode && ! can_diff
223 then
224 echo "error: '$tool' can only be used to resolve merges" >&2
62957bea 225 return 1
bc7a96a8
DA
226 fi
227 return 0
21d0ba7e
DA
228}
229
230get_merge_tool_cmd () {
bc7a96a8 231 merge_tool="$1"
240dc3e8
DA
232 if diff_mode
233 then
80ff2b68
DA
234 git config "difftool.$merge_tool.cmd" ||
235 git config "mergetool.$merge_tool.cmd"
47d65924 236 else
80ff2b68 237 git config "mergetool.$merge_tool.cmd"
47d65924 238 fi
21d0ba7e
DA
239}
240
7c10605d
DA
241trust_exit_code () {
242 if git config --bool "mergetool.$1.trustExitCode"
243 then
244 :; # OK
245 elif exit_code_trustable
246 then
247 echo true
248 else
249 echo false
250 fi
251}
252
253
bc7a96a8 254# Entry point for running tools
21d0ba7e 255run_merge_tool () {
f9ad901f
DA
256 # If GIT_PREFIX is empty then we cannot use it in tools
257 # that expect to be able to chdir() to its value.
258 GIT_PREFIX=${GIT_PREFIX:-.}
259 export GIT_PREFIX
260
80ff2b68 261 merge_tool_path=$(get_merge_tool_path "$1") || exit
21d0ba7e 262 base_present="$2"
21d0ba7e 263
bc7a96a8 264 # Bring tool-specific functions into scope
d2512fc9 265 setup_tool "$1" || return 1
bc7a96a8
DA
266
267 if merge_mode
268 then
a427ef7a 269 run_merge_cmd "$1"
bc7a96a8 270 else
a427ef7a 271 run_diff_cmd "$1"
bc7a96a8 272 fi
21d0ba7e
DA
273}
274
a427ef7a
DA
275# Run a either a configured or built-in diff tool
276run_diff_cmd () {
d2512fc9 277 diff_cmd "$1"
a427ef7a
DA
278}
279
280# Run a either a configured or built-in merge tool
281run_merge_cmd () {
7c10605d
DA
282 mergetool_trust_exit_code=$(trust_exit_code "$1")
283 if test "$mergetool_trust_exit_code" = "true"
284 then
285 merge_cmd "$1"
286 else
287 touch "$BACKUP"
288 merge_cmd "$1"
289 check_unchanged
290 fi
a427ef7a
DA
291}
292
109859e2 293list_merge_tool_candidates () {
240dc3e8
DA
294 if merge_mode
295 then
21d0ba7e
DA
296 tools="tortoisemerge"
297 else
298 tools="kompare"
299 fi
240dc3e8
DA
300 if test -n "$DISPLAY"
301 then
302 if test -n "$GNOME_DESKTOP_SESSION_ID"
303 then
21d0ba7e
DA
304 tools="meld opendiff kdiff3 tkdiff xxdiff $tools"
305 else
306 tools="opendiff kdiff3 tkdiff xxdiff meld $tools"
307 fi
c5f424fd 308 tools="$tools gvimdiff diffuse diffmerge ecmerge"
f13f9b0e 309 tools="$tools p4merge araxis bc codecompare"
eb12adc7 310 tools="$tools smerge"
21d0ba7e 311 fi
7b104229 312 case "${VISUAL:-$EDITOR}" in
11868978 313 *nvim*)
314 tools="$tools nvimdiff vimdiff emerge"
315 ;;
7b104229 316 *vim*)
11868978 317 tools="$tools vimdiff nvimdiff emerge"
7b104229
RS
318 ;;
319 *)
11868978 320 tools="$tools emerge vimdiff nvimdiff"
7b104229
RS
321 ;;
322 esac
109859e2
JH
323}
324
4a8273a3 325show_tool_help () {
2b7ca916 326 tool_opt="'git ${TOOL_MODE}tool --tool=<tool>'"
88d3406a 327
17a1f1c5
DA
328 tab=' '
329 LF='
330'
331 any_shown=no
62b6f7e0
JK
332
333 cmd_name=${TOOL_MODE}tool
665682c9
JK
334 config_tools=$({
335 diff_mode && list_config_tools difftool "$tab$tab"
336 list_config_tools mergetool "$tab$tab"
337 } | sort)
338 extra_content=
339 if test -n "$config_tools"
340 then
341 extra_content="${tab}user-defined:${LF}$config_tools"
342 fi
343
17a1f1c5
DA
344 show_tool_names 'mode_ok && is_available' "$tab$tab" \
345 "$tool_opt may be set to one of the following:" \
665682c9
JK
346 "No suitable tool for 'git $cmd_name --tool=<tool>' found." \
347 "$extra_content" &&
17a1f1c5
DA
348 any_shown=yes
349
350 show_tool_names 'mode_ok && ! is_available' "$tab$tab" \
351 "${LF}The following tools are valid, but not currently available:" &&
352 any_shown=yes
353
354 if test "$any_shown" = yes
4a8273a3
JK
355 then
356 echo
357 echo "Some of the tools listed above only work in a windowed"
358 echo "environment. If run in a terminal-only session, they will fail."
359 fi
360 exit 0
361}
362
109859e2
JH
363guess_merge_tool () {
364 list_merge_tool_candidates
5338a6a9
DA
365 cat >&2 <<-EOF
366
367 This message is displayed because '$TOOL_MODE.tool' is not configured.
368 See 'git ${TOOL_MODE}tool --tool-help' or 'git help config' for more details.
369 'git ${TOOL_MODE}tool' will now attempt to use one of the following tools:
370 $tools
371 EOF
21d0ba7e
DA
372
373 # Loop over each candidate and stop when a valid merge tool is found.
f67986b9 374 IFS=' '
17a1f1c5 375 for tool in $tools
21d0ba7e 376 do
17a1f1c5 377 is_available "$tool" && echo "$tool" && return 0
21d0ba7e
DA
378 done
379
17a1f1c5 380 echo >&2 "No known ${TOOL_MODE} tool is available."
47d65924 381 return 1
21d0ba7e
DA
382}
383
384get_configured_merge_tool () {
60aced3d 385 keys=
240dc3e8
DA
386 if diff_mode
387 then
60aced3d
DL
388 if gui_mode
389 then
390 keys="diff.guitool merge.guitool diff.tool merge.tool"
391 else
392 keys="diff.tool merge.tool"
393 fi
47d65924 394 else
60aced3d
DL
395 if gui_mode
396 then
397 keys="merge.guitool merge.tool"
398 else
399 keys="merge.tool"
400 fi
21d0ba7e 401 fi
60aced3d
DL
402
403 merge_tool=$(
404 IFS=' '
405 for key in $keys
406 do
407 selected=$(git config $key)
408 if test -n "$selected"
409 then
410 echo "$selected"
411 return
412 fi
413 done)
414
240dc3e8
DA
415 if test -n "$merge_tool" && ! valid_tool "$merge_tool"
416 then
063f2bdb 417 echo >&2 "git config option $TOOL_MODE.${gui_prefix}tool set to unknown tool: $merge_tool"
21d0ba7e
DA
418 echo >&2 "Resetting to default..."
419 return 1
420 fi
47d65924 421 echo "$merge_tool"
21d0ba7e
DA
422}
423
424get_merge_tool_path () {
425 # A merge tool has been set, so verify that it's valid.
bc7a96a8 426 merge_tool="$1"
240dc3e8
DA
427 if ! valid_tool "$merge_tool"
428 then
21d0ba7e
DA
429 echo >&2 "Unknown merge tool $merge_tool"
430 exit 1
431 fi
240dc3e8
DA
432 if diff_mode
433 then
47d65924 434 merge_tool_path=$(git config difftool."$merge_tool".path ||
285c6cbf 435 git config mergetool."$merge_tool".path)
47d65924
DA
436 else
437 merge_tool_path=$(git config mergetool."$merge_tool".path)
21d0ba7e 438 fi
240dc3e8
DA
439 if test -z "$merge_tool_path"
440 then
80ff2b68 441 merge_tool_path=$(translate_merge_tool_path "$merge_tool")
21d0ba7e 442 fi
47d65924 443 if test -z "$(get_merge_tool_cmd "$merge_tool")" &&
240dc3e8
DA
444 ! type "$merge_tool_path" >/dev/null 2>&1
445 then
47d65924 446 echo >&2 "The $TOOL_MODE tool $merge_tool is not available as"\
285c6cbf 447 "'$merge_tool_path'"
21d0ba7e
DA
448 exit 1
449 fi
450 echo "$merge_tool_path"
451}
452
453get_merge_tool () {
05fb8726 454 is_guessed=false
21d0ba7e 455 # Check if a merge tool has been configured
80ff2b68 456 merge_tool=$(get_configured_merge_tool)
21d0ba7e 457 # Try to guess an appropriate merge tool if no tool has been set.
240dc3e8
DA
458 if test -z "$merge_tool"
459 then
80ff2b68 460 merge_tool=$(guess_merge_tool) || exit
05fb8726 461 is_guessed=true
21d0ba7e
DA
462 fi
463 echo "$merge_tool"
05fb8726 464 test "$is_guessed" = false
21d0ba7e 465}
e36d7167
JN
466
467mergetool_find_win32_cmd () {
468 executable=$1
469 sub_directory=$2
470
471 # Use $executable if it exists in $PATH
472 if type -p "$executable" >/dev/null 2>&1
473 then
474 printf '%s' "$executable"
475 return
476 fi
477
478 # Look for executable in the typical locations
479 for directory in $(env | grep -Ei '^PROGRAM(FILES(\(X86\))?|W6432)=' |
480 cut -d '=' -f 2- | sort -u)
481 do
482 if test -n "$directory" && test -x "$directory/$sub_directory/$executable"
483 then
484 printf '%s' "$directory/$sub_directory/$executable"
485 return
486 fi
487 done
488
489 printf '%s' "$executable"
490}